<?php
/**
 * @package		Testimonial
 * @copyright	Copyright (C) 2015 Fido-X IT (John Simon). All rights reserved. (fido-x.net)
 * @license		GNU General Public License version 3; see http://www.gnu.org/licenses/gpl-3.0.en.html
 */

class ControllerExtensionModuleTestimonial extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/testimonial');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
			$this->model_setting_setting->editSetting('module_testimonial', $this->request->post);		

			$this->session->data['success'] = $this->language->get('text_success');

			//$this->response->redirect($this->url->link('extension/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true));
		
			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true));
		}

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_yes'] = $this->language->get('text_yes');
		$data['text_no'] = $this->language->get('text_no');
		$data['text_view_list'] = sprintf($this->language->get('text_view_list'), $this->url->link('extension/module/testimonial/view_list', 'user_token=' . $this->session->data['user_token'], true));

		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_limit'] = $this->language->get('entry_limit');
		$data['entry_module_excerpt'] = $this->language->get('entry_module_excerpt');
		$data['entry_numchars'] = $this->language->get('entry_numchars');
		$data['entry_show_rating'] = $this->language->get('entry_show_rating');
		$data['entry_module_photo'] = $this->language->get('entry_module_photo');
		$data['entry_photo_size'] = $this->language->get('entry_photo_size');
		$data['entry_width'] = $this->language->get('entry_width');
		$data['entry_height'] = $this->language->get('entry_height');
		$data['entry_pagination_limit'] = $this->language->get('entry_pagination_limit');
		$data['entry_page_photo'] = $this->language->get('entry_page_photo');
		$data['entry_page_excerpt'] = $this->language->get('entry_page_excerpt');
		$data['entry_auto_approve'] = $this->language->get('entry_auto_approve');
		$data['entry_login_required'] = $this->language->get('entry_login_required');

		$data['help_limit'] = $this->language->get('help_limit');
		$data['help_module_excerpt'] = $this->language->get('help_module_excerpt');
		$data['help_module_numchars'] = $this->language->get('help_module_numchars');
		$data['help_module_photo'] = $this->language->get('help_module_photo');
		$data['help_module_photo_size'] = $this->language->get('help_module_photo_size');
		$data['help_module_rating'] = $this->language->get('help_module_rating');
		$data['help_pagination_limit'] = $this->language->get('help_pagination_limit');
		$data['help_page_excerpt'] = $this->language->get('help_page_excerpt');
		$data['help_page_numchars'] = $this->language->get('help_page_numchars');
		$data['help_page_photo'] = $this->language->get('help_page_photo');
		$data['help_page_photo_size'] = $this->language->get('help_page_photo_size');
		$data['help_page_rating'] = $this->language->get('help_page_rating');
		$data['help_auto_approve'] = $this->language->get('help_auto_approve');
		$data['help_login_required'] = $this->language->get('help_login_required');

		$data['tab_module'] = $this->language->get('tab_module');
		$data['tab_page'] = $this->language->get('tab_page');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['module_numchars'])) {
			$data['error_module_numchars'] = $this->error['module_numchars'];
		} else {
			$data['error_module_numchars'] = '';
		}

		if (isset($this->error['module_photo'])) {
			$data['error_module_photo'] = $this->error['module_photo'];
		} else {
			$data['error_module_photo'] = '';
		}

		if (isset($this->error['page_numchars'])) {
			$data['error_page_numchars'] = $this->error['page_numchars'];
		} else {
			$data['error_page_numchars'] = '';
		}

		if (isset($this->error['page_photo'])) {
			$data['error_page_photo'] = $this->error['page_photo'];
		} else {
			$data['error_page_photo'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('extension/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/module/testimonial', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['action'] = $this->url->link('extension/module/testimonial', 'user_token=' . $this->session->data['user_token'], true);

		$data['cancel'] = $this->url->link('extension/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true);

		if (isset($this->request->post['module_testimonial_status'])) {
			$data['module_testimonial_status'] = $this->request->post['module_testimonial_status'];
		} else {
			$data['module_testimonial_status'] = $this->config->get('module_testimonial_status');
		}

		if (isset($this->request->post['module_testimonial_limit'])) {
			$data['module_testimonial_limit'] = $this->request->post['module_testimonial_limit'];
		} else {
			$data['module_testimonial_limit'] = $this->config->get('module_testimonial_limit');
		}

		if (isset($this->request->post['module_testimonial_excerpt'])) {
			$data['module_testimonial_excerpt'] = $this->request->post['module_testimonial_excerpt'];
		} else {
			$data['module_testimonial_excerpt'] = $this->config->get('module_testimonial_excerpt');
		}

		if (isset($this->request->post['module_testimonial_numchars'])) {
			$data['module_testimonial_numchars'] = $this->request->post['module_testimonial_numchars'];
		} else {
			$data['module_testimonial_numchars'] = $this->config->get('module_testimonial_numchars');
		}

		if (isset($this->request->post['module_testimonial_photo'])) {
			$data['module_testimonial_photo'] = $this->request->post['module_testimonial_photo'];
		} else {
			$data['module_testimonial_photo'] = $this->config->get('module_testimonial_photo');
		}

		if (isset($this->request->post['module_testimonial_photo_width'])) {
			$data['module_testimonial_photo_width'] = $this->request->post['module_testimonial_photo_width'];
		} elseif ($this->config->get('module_testimonial_photo_width')) {
			$data['module_testimonial_photo_width'] = $this->config->get('module_testimonial_photo_width');
		} else {
			$data['module_testimonial_photo_width'] = 40;
		}

		if (isset($this->request->post['module_testimonial_photo_height'])) {
			$data['module_testimonial_photo_height'] = $this->request->post['module_testimonial_photo_height'];
		} elseif ($this->config->get('module_testimonial_photo_height')) {
			$data['module_testimonial_photo_height'] = $this->config->get('module_testimonial_photo_height');
		} else {
			$data['module_testimonial_photo_height'] = 40;
		}

		if (isset($this->request->post['module_testimonial_rating'])) {
			$data['module_testimonial_rating'] = $this->request->post['module_testimonial_rating'];
		} else {
			$data['module_testimonial_rating'] = $this->config->get('module_testimonial_rating');
		}

		if (isset($this->request->post['module_testimonial_pagination_limit'])) {
			$data['module_testimonial_pagination_limit'] = $this->request->post['module_testimonial_pagination_limit'];
		} else {
			$data['module_testimonial_pagination_limit'] = $this->config->get('module_testimonial_pagination_limit');
		}

		if (isset($this->request->post['module_testimonial_page_excerpt'])) {
			$data['module_testimonial_page_excerpt'] = $this->request->post['module_testimonial_page_excerpt'];
		} else {
			$data['module_testimonial_page_excerpt'] = $this->config->get('module_testimonial_page_excerpt');
		}

		if (isset($this->request->post['module_testimonial_page_numchars'])) {
			$data['module_testimonial_page_numchars'] = $this->request->post['module_testimonial_page_numchars'];
		} else {
			$data['module_testimonial_page_numchars'] = $this->config->get('module_testimonial_page_numchars');
		}

		if (isset($this->request->post['module_testimonial_page_photo'])) {
			$data['module_testimonial_page_photo'] = $this->request->post['module_testimonial_page_photo'];
		} else {
			$data['module_testimonial_page_photo'] = $this->config->get('module_testimonial_page_photo');
		}

		if (isset($this->request->post['module_testimonial_page_photo_width'])) {
			$data['module_testimonial_page_photo_width'] = $this->request->post['module_testimonial_page_photo_width'];
		} elseif ($this->config->get('module_testimonial_page_photo_width')) {
			$data['module_testimonial_page_photo_width'] = $this->config->get('module_testimonial_page_photo_width');
		} else {
			$data['module_testimonial_page_photo_width'] = 80;
		}

		if (isset($this->request->post['module_testimonial_page_photo_height'])) {
			$data['module_testimonial_page_photo_height'] = $this->request->post['module_testimonial_page_photo_height'];
		} elseif ($this->config->get('module_testimonial_page_photo_height')) {
			$data['module_testimonial_page_photo_height'] = $this->config->get('module_testimonial_page_photo_height');
		} else {
			$data['module_testimonial_page_photo_height'] = 80;
		}

		if (isset($this->request->post['module_testimonial_page_rating'])) {
			$data['module_testimonial_page_rating'] = $this->request->post['module_testimonial_page_rating'];
		} else {
			$data['module_testimonial_page_rating'] = $this->config->get('module_testimonial_page_rating');
		}

		if (isset($this->request->post['module_testimonial_auto_approve'])) {
			$data['module_testimonial_auto_approve'] = $this->request->post['module_testimonial_auto_approve'];
		} else {
			$data['module_testimonial_auto_approve'] = $this->config->get('module_testimonial_auto_approve');
		}

		if (isset($this->request->post['module_testimonial_login_required'])) {
			$data['module_testimonial_login_required'] = $this->request->post['module_testimonial_login_required'];
		} else {
			$data['module_testimonial_login_required'] = $this->config->get('module_testimonial_login_required');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/testimonial', $data));
	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'extension/module/testimonial')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if ($this->request->post['module_testimonial_excerpt'] && ($this->request->post['module_testimonial_numchars'] < 10)) {
			$this->error['module_numchars'] = $this->language->get('error_numchars');
		}

		if (!$this->request->post['module_testimonial_photo_width'] || !$this->request->post['module_testimonial_photo_height']) {
			$this->error['module_photo'] = $this->language->get('error_photo');
		}

		if ($this->request->post['module_testimonial_page_excerpt'] && ($this->request->post['module_testimonial_page_numchars'] < 10)) {
			$this->error['page_numchars'] = $this->language->get('error_numchars');
		}

		if (!$this->request->post['module_testimonial_page_photo_width'] || !$this->request->post['module_testimonial_page_photo_height']) {
			$this->error['page_photo'] = $this->language->get('error_photo');
		}

		if ($this->error && !isset($this->error['warning'])) {
			$this->error['warning'] = $this->language->get('error_warning');
		}

		return !$this->error;
	}

	public function install() {
		$this->load->model('fido/testimonial');

		$this->model_fido_testimonial->createTestimonials();
	}

	public function uninstall() {
		$this->load->model('fido/testimonial');

		$this->model_fido_testimonial->dropTestimonials();
	}

	public function add() {
		$this->load->language('extension/module/testimonial');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('fido/testimonial');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {
			$this->model_fido_testimonial->addTestimonial($this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			$this->response->redirect($this->url->link('extension/module/testimonial/view_list', 'user_token=' . $this->session->data['user_token'] . $url, true));
		}

		$this->getForm();
	}

	public function edit() {
		$this->load->language('extension/module/testimonial');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('fido/testimonial');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {
			$this->model_fido_testimonial->editTestimonial($this->request->get['testimonial_id'], $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			$this->response->redirect($this->url->link('extension/module/testimonial/view_list', 'user_token=' . $this->session->data['user_token'] . $url, true));
		}

		$this->getForm();
	}

	public function delete() {
		$this->load->language('extension/module/testimonial');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('fido/testimonial');

		if (isset($this->request->post['selected']) && $this->validateDelete()) {
			foreach ($this->request->post['selected'] as $testimonial_id) {
				$this->model_fido_testimonial->deleteTestimonial($testimonial_id);
			}

			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			$this->response->redirect($this->url->link('extension/module/testimonial/view_list', 'user_token=' . $this->session->data['user_token'] . $url, true));
		}

		$this->getList();
	}

	public function enable() {
		$this->load->model('fido/testimonial');

		$this->model_fido_testimonial->enableTestimonial($this->request->get['testimonial_id']);

		$url = '';

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$this->response->redirect($this->url->link('extension/module/testimonial/view_list', 'user_token=' . $this->session->data['user_token'] . $url, true));
	}

	public function disable() {
		$this->load->model('fido/testimonial');

		$this->model_fido_testimonial->disableTestimonial($this->request->get['testimonial_id']);

		$url = '';

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$this->response->redirect($this->url->link('extension/module/testimonial/view_list', 'user_token=' . $this->session->data['user_token'] . $url, true));
	}

	public function feature() {
		$this->load->model('fido/testimonial');

		$this->model_fido_testimonial->featureTestimonial($this->request->get['testimonial_id']);

		$url = '';

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$this->response->redirect($this->url->link('extension/module/testimonial/view_list', 'user_token=' . $this->session->data['user_token'] . $url, true));
	}

	public function unfeature() {
		$this->load->model('fido/testimonial');

		$this->model_fido_testimonial->unfeatureTestimonial($this->request->get['testimonial_id']);

		$url = '';

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$this->response->redirect($this->url->link('extension/module/testimonial/view_list', 'user_token=' . $this->session->data['user_token'] . $url, true));
	}

	public function view_list() {
		$this->load->language('extension/module/testimonial');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('fido/testimonial');

		$this->getlist();
	}

	protected function getList() {
		if (isset($this->request->get['sort'])) {
			$sort = $this->request->get['sort'];
		} else {
			$sort = 'date_added';
		}

		if (isset($this->request->get['order'])) {
			$order = $this->request->get['order'];
		} else {
			$order = 'DESC';
		}

		if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('extension/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/module/testimonial/view_list', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['return'] = $this->url->link('extension/module/testimonial', 'user_token=' . $this->session->data['user_token'], true);
		$data['add'] = $this->url->link('extension/module/testimonial/add', 'user_token=' . $this->session->data['user_token'], true);
		$data['delete'] = $this->url->link('extension/module/testimonial/delete', 'user_token=' . $this->session->data['user_token'] . $url, true);

		$data['testimonials'] = array();

		$filter_data = array(
			'sort'  => $sort,
			'order' => $order,
			'start' => ($page - 1) * $this->config->get('config_limit_admin'),
			'limit' => $this->config->get('config_limit_admin')
		);

		$testimonial_total = $this->model_fido_testimonial->getTotalTestimonials();
		$results = $this->model_fido_testimonial->getTestimonials($filter_data);

		foreach ($results as $result) {
			$data['testimonials'][] = array(
				'testimonial_id' => $result['testimonial_id'],
				'name'           => $result['firstname'] . ' ' . $result['lastname'],
				'email'          => $result['email'],
				'status'         => ($result['status'] ? $this->language->get('text_enabled') : $this->language->get('text_disabled')),
				'featured'       => ($result['featured'] ? $this->language->get('text_yes') : $this->language->get('text_no')),
				'rating'         => $result['rating'],
				'date_added'     => date($this->language->get('date_format_short'), strtotime($result['date_added'])),
				'is_enabled'     => $result['status'],
				'is_featured'    => $result['featured'],
				'feature'        => $this->url->link('extension/module/testimonial/feature', 'user_token=' . $this->session->data['user_token'] . '&testimonial_id=' . $result['testimonial_id'] . $url, true),
				'unfeature'      => $this->url->link('extension/module/testimonial/unfeature', 'user_token=' . $this->session->data['user_token'] . '&testimonial_id=' . $result['testimonial_id'] . $url, true),
				'enable'         => $this->url->link('extension/module/testimonial/enable', 'user_token=' . $this->session->data['user_token'] . '&testimonial_id=' . $result['testimonial_id'] . $url, true),
				'disable'        => $this->url->link('extension/module/testimonial/disable', 'user_token=' . $this->session->data['user_token'] . '&testimonial_id=' . $result['testimonial_id'] . $url, true),
				'edit'           => $this->url->link('extension/module/testimonial/edit', 'user_token=' . $this->session->data['user_token'] . '&testimonial_id=' . $result['testimonial_id'] . $url, true)
			);
		}

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_list'] = $this->language->get('text_list');
		$data['text_no_results'] = $this->language->get('text_no_results');
		$data['text_confirm'] = $this->language->get('text_confirm');

		$data['column_name'] = $this->language->get('column_name');
		$data['column_email'] = $this->language->get('column_email');
		$data['column_status'] = $this->language->get('column_status');
		$data['column_featured'] = $this->language->get('column_featured');
		$data['column_rating'] = $this->language->get('column_rating');
		$data['column_date_added'] = $this->language->get('column_date_added');
		$data['column_action'] = $this->language->get('column_action');		

		$data['button_add'] = $this->language->get('button_add');
		$data['button_feature'] = $this->language->get('button_feature');
		$data['button_unfeature'] = $this->language->get('button_unfeature');
		$data['button_enable'] = $this->language->get('button_enable');
		$data['button_disable'] = $this->language->get('button_disable');
		$data['button_edit'] = $this->language->get('button_edit');
		$data['button_delete'] = $this->language->get('button_delete');
		$data['button_return'] = $this->language->get('button_return');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset($this->request->post['selected'])) {
			$data['selected'] = (array)$this->request->post['selected'];
		} else {
			$data['selected'] = array();
		}

		$url = '';

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$data['sort_lastname'] = $this->url->link('extension/module/testimonial/view_list', 'user_token=' . $this->session->data['user_token'] . '&sort=lastname' . $url, true);
		$data['sort_email'] = $this->url->link('extension/module/testimonial/view_list', 'user_token=' . $this->session->data['user_token'] . '&sort=email' . $url, true);
		$data['sort_status'] = $this->url->link('extension/module/testimonial/view_list', 'user_token=' . $this->session->data['user_token'] . '&sort=status' . $url, true);
		$data['sort_featured'] = $this->url->link('extension/module/testimonial/view_list', 'user_token=' . $this->session->data['user_token'] . '&sort=featured' . $url, true);
		$data['sort_rating'] = $this->url->link('extension/module/testimonial/view_list', 'user_token=' . $this->session->data['user_token'] . '&sort=rating' . $url, true);
		$data['sort_date_added'] = $this->url->link('extension/module/testimonial/view_list', 'user_token=' . $this->session->data['user_token'] . '&sort=date_added' . $url, true);

		$url = '';

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		$pagination = new Pagination();
		$pagination->total = $testimonial_total;
		$pagination->page = $page;
		$pagination->limit = $this->config->get('config_limit_admin');
		$pagination->url = $this->url->link('extension/module/testimonial/view_list', 'user_token=' . $this->session->data['user_token'] . $url . '&page={page}', true);

		$data['pagination'] = $pagination->render();

		$data['results'] = sprintf($this->language->get('text_pagination'), ($testimonial_total) ? (($page - 1) * $this->config->get('config_limit_admin')) + 1 : 0, ((($page - 1) * $this->config->get('config_limit_admin')) > ($testimonial_total - $this->config->get('config_limit_admin'))) ? $testimonial_total : ((($page - 1) * $this->config->get('config_limit_admin')) + $this->config->get('config_limit_admin')), $testimonial_total, ceil($testimonial_total / $this->config->get('config_limit_admin')));

		$data['sort'] = $sort;
		$data['order'] = $order;

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/testimonials/list', $data));
	}

	protected function validateDelete() {
		if (!$this->user->hasPermission('modify', 'extension/module/testimonial')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}

	protected function getForm() {
		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_form'] = !isset($this->request->get['testimonial_id']) ? $this->language->get('text_add') : $this->language->get('text_form');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_yes'] = $this->language->get('text_yes');
		$data['text_no'] = $this->language->get('text_no');
		$data['text_default'] = $this->language->get('text_default');

		$data['entry_firstname'] = $this->language->get('entry_firstname');
		$data['entry_lastname'] = $this->language->get('entry_lastname');
		$data['entry_email'] = $this->language->get('entry_email');
		$data['entry_website'] = $this->language->get('entry_website');
		$data['entry_company'] = $this->language->get('entry_company');
		$data['entry_title'] = $this->language->get('entry_title');
		$data['entry_testimony'] = $this->language->get('entry_testimony');
		$data['entry_rating'] = $this->language->get('entry_rating');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_language'] = $this->language->get('entry_language');
		$data['entry_featured'] = $this->language->get('entry_featured');
		$data['entry_photo'] = $this->language->get('entry_photo');
		$data['entry_store'] = $this->language->get('entry_store');

		$data['help_website'] = $this->language->get('help_website');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['firstname'])) {
			$data['error_firstname'] = $this->error['firstname'];
		} else {
			$data['error_firstname'] = '';
		}

		if (isset($this->error['lastname'])) {
			$data['error_lastname'] = $this->error['lastname'];
		} else {
			$data['error_lastname'] = '';
		}

		if (isset($this->error['email'])) {
			$data['error_email'] = $this->error['email'];
		} else {
			$data['error_email'] = '';
		}

		if (isset($this->error['testimony'])) {
			$data['error_testimony'] = $this->error['testimony'];
		} else {
			$data['error_testimony'] = '';
		}

		if (isset($this->error['rating'])) {
			$data['error_rating'] = $this->error['rating'];
		} else {
			$data['error_rating'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('extension/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/module/testimonial/view_list', 'user_token=' . $this->session->data['user_token'], true)
		);

		if (isset($this->request->get['testimonial_id'])) {
			$data['action'] = $this->url->link('extension/module/testimonial/edit', 'user_token=' . $this->session->data['user_token'] . '&testimonial_id=' . $this->request->get['testimonial_id'], true);
		} else {
			$data['action'] = $this->url->link('extension/module/testimonial/add', 'user_token=' . $this->session->data['user_token'], true);
		}

		if (isset($this->request->get['testimonial_id']) && ($this->request->server['REQUEST_METHOD'] != 'POST')) {
			$testimonial_info = $this->model_fido_testimonial->getTestimonial($this->request->get['testimonial_id']);
		}

		$data['cancel'] = $this->url->link('extension/module/testimonial/view_list', 'user_token=' . $this->session->data['user_token'], true);

		$data['user_token'] = $this->session->data['user_token'];

		if (isset($this->request->post['firstname'])) {
			$data['firstname'] = $this->request->post['firstname'];
		} elseif (!empty($testimonial_info)) {
			$data['firstname'] = $testimonial_info['firstname'];
		} else {
			$data['firstname'] = '';
		}

		if (isset($this->request->post['lastname'])) {
			$data['lastname'] = $this->request->post['lastname'];
		} elseif (!empty($testimonial_info)) {
			$data['lastname'] = $testimonial_info['lastname'];
		} else {
			$data['lastname'] = '';
		}

		if (isset($this->request->post['email'])) {
			$data['email'] = $this->request->post['email'];
		} elseif (!empty($testimonial_info)) {
			$data['email'] = $testimonial_info['email'];
		} else {
			$data['email'] = '';
		}

		if (isset($this->request->post['website'])) {
			$data['website'] = $this->request->post['website'];
		} elseif (!empty($testimonial_info)) {
			$data['website'] = $testimonial_info['website'];
		} else {
			$data['website'] = '';
		}

		if (isset($this->request->post['company'])) {
			$data['company'] = $this->request->post['company'];
		} elseif (!empty($testimonial_info)) {
			$data['company'] = $testimonial_info['company'];
		} else {
			$data['company'] = '';
		}

		if (isset($this->request->post['title'])) {
			$data['title'] = $this->request->post['title'];
		} elseif (!empty($testimonial_info)) {
			$data['title'] = $testimonial_info['title'];
		} else {
			$data['title'] = '';
		}

		if (isset($this->request->post['testimony'])) {
			$data['testimony'] = $this->request->post['testimony'];
		} elseif (!empty($testimonial_info)) {
			$data['testimony'] = $testimonial_info['testimony'];
		} else {
			$data['testimony'] = '';
		}

		if (isset($this->request->post['rating'])) {
			$data['rating'] = $this->request->post['rating'];
		} elseif (!empty($testimonial_info)) {
			$data['rating'] = $testimonial_info['rating'];
		} else {
			$data['rating'] = '';
		}

		if (isset($this->request->post['status'])) {
			$data['status'] = $this->request->post['status'];
		} elseif (!empty($testimonial_info)) {
			$data['status'] = $testimonial_info['status'];
		} else {
			$data['status'] = '';
		}

		$this->load->model('localisation/language');

		$data['languages'] = $this->model_localisation_language->getLanguages();

		if (isset($this->request->post['language_code'])) {
			$data['language_code'] = $this->request->post['language_code'];
		} elseif (!empty($testimonial_info)) {
			$data['language_code'] = $testimonial_info['language_code'];
		} else {
			$data['language_code'] = '';
		}

		if (isset($this->request->post['featured'])) {
			$data['featured'] = $this->request->post['featured'];
		} elseif (!empty($testimonial_info)) {
			$data['featured'] = $testimonial_info['featured'];
		} else {
			$data['featured'] = '';
		}

		if (isset($this->request->post['image'])) {
			$data['image'] = $this->request->post['image'];
		} elseif (!empty($testimonial_info)) {
			$data['image'] = $testimonial_info['image'];
		} else {
			$data['image'] = '';
		}

		$this->load->model('tool/image');

		if (isset($this->request->post['image']) && is_file(DIR_IMAGE . $this->request->post['image'])) {
			$data['thumb'] = $this->model_tool_image->resize($this->request->post['image'], 100, 100);
		} elseif (!empty($testimonial_info) && is_file(DIR_IMAGE . $testimonial_info['image'])) {
			$data['thumb'] = $this->model_tool_image->resize($testimonial_info['image'], 100, 100);
		} else {
			$data['thumb'] = $this->model_tool_image->resize('no_photo.jpg', 100, 100);
		}

		$data['placeholder'] = $this->model_tool_image->resize('no_photo.jpg', 100, 100);

		$this->load->model('setting/store');

		$data['stores'] = $this->model_setting_store->getStores();

		if (isset($this->request->post['testimonial_store'])) {
			$data['testimonial_store'] = $this->request->post['testimonial_store'];
		} elseif (isset($this->request->get['testimonial_id'])) {
			$data['testimonial_store'] = $this->model_fido_testimonial->getTestimonialStores($this->request->get['testimonial_id']);
		} else {
			$data['testimonial_store'] = array(0);
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/testimonials/form', $data));
	}

	protected function validateForm() {
		if (!$this->user->hasPermission('modify', 'extension/module/testimonial')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if ((utf8_strlen($this->request->post['firstname']) < 1) || (utf8_strlen($this->request->post['firstname']) > 32)) {
      		$this->error['firstname'] = $this->language->get('error_firstname');
    	}

		if ((utf8_strlen($this->request->post['lastname']) < 1) || (utf8_strlen($this->request->post['lastname']) > 32)) {
      		$this->error['lastname'] = $this->language->get('error_lastname');
    	}

		$pattern = '/^[A-Z0-9._%-]+@[A-Z0-9][A-Z0-9.-]{0,61}[A-Z0-9]\.[A-Z]{2,6}$/i';

		if ((utf8_strlen($this->request->post['email']) > 96) || !preg_match($pattern, $this->request->post['email'])) {
      		$this->error['email'] = $this->language->get('error_email');
		}

		$this->load->model('fido/testimonial');

		if (!isset($this->request->get['testimonial_id'])) {
			if ($this->model_fido_testimonial->emailExists($this->request->post['email'])) {
	      		$this->error['email'] = $this->language->get('error_email_exists');
			}
		}

		if (utf8_strlen($this->request->post['testimony']) < 3) {
      		$this->error['testimony'] = $this->language->get('error_testimony');
    	}

		if (!isset($this->request->post['rating']) || !$this->request->post['rating']) {
			$this->error['rating'] = $this->language->get('error_rating');
		}

		if ($this->error && !isset($this->error['warning'])) {
			$this->error['warning'] = $this->language->get('error_warning');
		}
		
		return !$this->error;
	}
}