<?php
class ControllerCommonFooter extends Controller {
	public function index() {
		
		$this->load->language('product/search');		
		$data['text_empty'] = $this->language->get('text_empty');		
				
        $data['text_view_all_results'] = $this->config->get('text_view_all_results');		
		$data['module_live_search_status'] = $this->config->get('module_live_search_status');		
		$data['module_live_search_show_image'] = $this->config->get('module_live_search_show_image');		
		$data['module_live_search_show_price'] = $this->config->get('module_live_search_show_price');		
		$data['module_live_search_show_description'] = $this->config->get('module_live_search_show_description');		
		$data['module_live_search_href'] = $this->url->link('product/search', 'search=');		
		$data['module_live_search_min_length'] = $this->config->get('module_live_search_min_length');


		$this->load->language('common/footer');

		$data['scripts'] = $this->document->getScripts('footer');		
		$data['text_information'] = $this->language->get('text_information');		
		$data['text_service'] = $this->language->get('text_service');		
		$data['text_extra'] = $this->language->get('text_extra');		
		$data['text_contact'] = $this->language->get('text_contact');		
		$data['text_return'] = $this->language->get('text_return');		
		$data['text_sitemap'] = $this->language->get('text_sitemap');		
		$data['text_manufacturer'] = $this->language->get('text_manufacturer');		
		$data['text_voucher'] = $this->language->get('text_voucher');		
		$data['text_affiliate'] = $this->language->get('text_affiliate');		
		$data['text_special'] = $this->language->get('text_special');		
		$data['text_account'] = $this->language->get('text_account');		
		$data['text_order'] = $this->language->get('text_order');		
		$data['text_wishlist'] = $this->language->get('text_wishlist');		
		$data['text_newsletter'] = $this->language->get('text_newsletter');


		$this->load->model('catalog/information');

		$data['testimonial'] = array( 'title' => 'Testimonials', 'href' => $this->url->link('testimonial/testimonial') );
		$data['informations'] = array();		
				
		$data['testimonial'] = array(		
                'title' => 'Testimonials',		
                'href'  => $this->url->link('testimonial/testimonial')		
        );


		foreach ($this->model_catalog_information->getInformations() as $result) {
			if ($result['bottom']) {
				$data['informations'][] = array(
					'title' => $result['title'],
					'href'  => $this->url->link('information/information', 'information_id=' . $result['information_id'])
				);
			}
		}

		$data['contact'] = $this->url->link('information/contact');
		$data['return'] = $this->url->link('account/return/add', '', true);
		$data['sitemap'] = $this->url->link('information/sitemap');
		$data['tracking'] = $this->url->link('information/tracking');
		$data['manufacturer'] = $this->url->link('product/manufacturer');
		$data['about']   = $this->url->link('information/about');
		$data['voucher'] = $this->url->link('account/voucher', '', true);
		$data['affiliate'] = $this->url->link('affiliate/login', '', true);
		$data['special'] = $this->url->link('product/special');
		$data['account'] = $this->url->link('account/account', '', true);
		$data['order'] = $this->url->link('account/order', '', true);
		$data['wishlist'] = $this->url->link('account/wishlist', '', true);
		$data['newsletter'] = $this->url->link('account/newsletter', '', true);

		$data['powered'] = sprintf($this->language->get('text_powered'), $this->config->get('config_name'), date('Y', time()));

		// Whos Online
		if ($this->config->get('config_customer_online')) {
			$this->load->model('tool/online');

			if (isset($this->request->server['REMOTE_ADDR'])) {
				$ip = $this->request->server['REMOTE_ADDR'];
			} else {
				$ip = '';
			}

			if (isset($this->request->server['HTTP_HOST']) && isset($this->request->server['REQUEST_URI'])) {
				$url = ($this->request->server['HTTPS'] ? 'https://' : 'http://') . $this->request->server['HTTP_HOST'] . $this->request->server['REQUEST_URI'];
			} else {
				$url = '';
			}

			if (isset($this->request->server['HTTP_REFERER'])) {
				$referer = $this->request->server['HTTP_REFERER'];
			} else {
				$referer = '';
			}

			$this->model_tool_online->addOnline($ip, $this->customer->getId(), $url, $referer);
		}

		$data['footer_top'] = $this->load->controller('common/footer_top');
		$data['footer_bottom'] = $this->load->controller('common/footer_bottom');
		$data['footer_left'] = $this->load->controller('common/footer_left');
		$data['footer_right'] = $this->load->controller('common/footer_right');
		$data['modal'] = $this->load->controller('common/modal');

		$data['scripts'] = $this->document->getScripts('footer');

		//echo "<pre>";print_r($data); exit();

		return $this->load->view('common/footer', $data);
	}
}
