<?php
class ControllerCommonMenu extends Controller {
	public function index() {
		$this->load->language('common/menu');

		// Menu
		$this->load->model('catalog/category');

		$this->load->model('catalog/product');

		$data['categories'] = array();

		//$categories = $this->model_catalog_category->getCategories(0);

		$categories = $this->model_catalog_category->getCategoriesWithLimit(0,5);

		foreach ($categories as $category) {
			if ($category['top']) {
				// Level 2
				$children_data = array();

				$children = $this->model_catalog_category->getCategories($category['category_id']);

				foreach ($children as $child) {
					$filter_data = array(
						'filter_category_id'  => $child['category_id'],
						'filter_sub_category' => true
					);

					$children_data2 = array();
	                $children2 = $this->model_catalog_category->getCategories($child['category_id']);
	                foreach ($children2 as $child2) {
	                    $children_data2[] = array(
	                    'name'  => $child2['name'],
	                    'href'  => $this->url->link('product/category', 'path=' . $category['category_id'] . '_' . $child['category_id'].'_'.$child2['category_id'])
	                    );
	                }

					$children_data[] = array(
						'children'=>$children_data2,
						'name'  => $child['name'] . ($this->config->get('config_product_count') ? ' (' . $this->model_catalog_product->getTotalProducts($filter_data) . ')' : ''),
						'href'  => $this->url->link('product/category', 'path=' . $category['category_id'] . '_' . $child['category_id'])
					);
				}

				$original = @getimagesize(DIR_IMAGE.$category['banner_image']);
				$catimage = $this->model_tool_image->resize($category['banner_image'], $original[0], $original[1]);

				// Level 1
				$data['categories'][] = array(
					'name'     => $category['name'],
					'catimage' => $catimage,
					'children' => $children_data,
					'column'   => $category['column'] ? $category['column'] : 1,
					'href'     => $this->url->link('product/category', 'path=' . $category['category_id'])
				);
			}

		}

		$data['all_blogs'] = $this->url->link('information/blogger/blogs');
		$data['text_blog'] = $this->language->get('text_blog');
		$data['about']   = $this->url->link('information/about');
		$data['testimonial'] = $this->url->link('information/testimonial');
		$data['contact'] = $this->url->link('information/contact');

		return $this->load->view('common/menu', $data);
	}
}
