<?php
class ControllerExtensionModuleFeaturedcarousel extends Controller {
	public function index($setting) {
		$this->load->language('extension/module/featuredcarousel');

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_tax'] = $this->language->get('text_tax');

		$data['button_cart'] = $this->language->get('button_cart');
		$data['button_quickview'] = $this->language->get('button_quickview');
		$data['button_wishlist'] = $this->language->get('button_wishlist');
		$data['button_compare'] = $this->language->get('button_compare');

		$this->load->model('catalog/product');

		$this->load->model('tool/image');

		if (file_exists('catalog/view/theme/actifuldefault/stylesheet/featuredcarousel.css')) {
		 
			$this->document->addStyle('catalog/view/theme/actifuldefault/stylesheet/featuredcarousel.css');
		}

		$data['products'] = array();

		$data['itemscolumn']   = (int)$setting['itemscolumn'];
		$data['itemspage']   = (int)$setting['itemspage'];

		if (!$setting['limit']) {
			$setting['limit'] = 4;
		}

		//echo "<pre>",print_r($setting); exit();
		$products = array_slice($setting['product'], 0, (int)$setting['limit']);

		foreach ($products as $product_id) {
				$product_info = $this->model_catalog_product->getProduct($product_id);

				if ($product_info) {
					if ($product_info['image']) {
						$image = $this->model_tool_image->resize($product_info['image'], $setting['width'], $setting['height']);
					} else {
						$image = $this->model_tool_image->resize('placeholder.png', $setting['width'], $setting['height']);
					}

					$images = $this->model_catalog_product->getProductImages($product_info['product_id']);
	
					if(isset($images[0]['image']) && !empty($images)){
					 $images = $images[0]['image']; 
					   }else
					   {
					   $images = $image;
					   }
					

					if ($this->customer->isLogged() || !$this->config->get('config_customer_price')) {
						$price = $this->currency->format($this->tax->calculate($product_info['price'], $product_info['tax_class_id'], $this->config->get('config_tax')), $this->session->data['currency']);
					} else {
						$price = false;
					}

					if ((float)$product_info['special']) {
						$special = $this->currency->format($this->tax->calculate($product_info['special'], $product_info['tax_class_id'], $this->config->get('config_tax')), $this->session->data['currency']);
					} else {
						$special = false;
					}

					if ($this->config->get('config_tax')) {
						$tax = $this->currency->format((float)$product_info['special'] ? $product_info['special'] : $product_info['price'], $this->session->data['currency']);
					} else {
						$tax = false;
					}

					if ($this->config->get('config_review_status')) {
						$rating = $product_info['rating'];
					} else {
						$rating = false;
					}

				$product_data = array(
					'product_id'  => $product_info['product_id'],
					'thumb_swap'  => $this->model_tool_image->resize($images , $setting['width'], $setting['height']),
					'thumb'       => $image,
					'name'        => $product_info['name'],
					'description' => utf8_substr(strip_tags(html_entity_decode($product_info['description'], ENT_QUOTES, 'UTF-8')), 0, $this->config->get('config_product_description_length')) . '..',
					'price'       => $price,
					'special'     => $special,
					'tax'         => $tax,
					'stock_status'=> $product_info['quantity'] <= 0 ? strtolower($product_info['stock_status']) : '',
					'rating'      => $rating,
					'href'        => $this->url->link('product/product', 'product_id=' . $product_info['product_id']),
					'quick'       => $this->url->link('product/quick_view','&product_id=' . $product_info['product_id'])
				);

				$data['products'][] = $this->load->controller('extension/module/product_box',$product_data);
			}
		}
		if ($data['products']) {
			return $this->load->view('extension/module/featuredcarousel', $data);
		}
	}
}