<?php
class ControllerExtensionModuleTestimonial extends Controller {
	public function index() {
		$this->load->language('extension/module/testimonial');
		$this->load->model('fido/testimonial');

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_more'] = $this->language->get('text_more');
		$data['text_testify'] = $this->language->get('text_testify');
		$data['text_more_testimonials'] = $this->language->get('text_more_testimonials');
		$data['text_no_testimonials'] = $this->language->get('text_no_testimonials');
		$data['text_date_added'] = $this->language->get('text_date_added');

		$data['show_excerpt'] = $this->config->get('module_testimonial_excerpt');

		$data['show_photo'] = $this->config->get('module_testimonial_photo');

		$data['show_rating'] = $this->config->get('module_testimonial_rating');

		$this->load->model('tool/image');

		$limit = $this->config->get('module_testimonial_pagination_limit');

		$data['testimonials'] = array();

		$filter_data = array(
			'language'  => $this->session->data['language'],
			'featured'  => 1,
			'start'     => 0,
			'limit'     => $limit
		);

		$results = $this->model_fido_testimonial->getTestimonials($filter_data);
		foreach ($results as $result) {
			if ($result['image'] && file_exists(DIR_IMAGE . $result['image'])) {
				$photo = $this->model_tool_image->resize($result['image'], $this->config->get('module_testimonial_photo_width'), $this->config->get('module_testimonial_photo_height'));
			} else {
				$photo = $this->model_tool_image->resize('no_photo.jpg', $this->config->get('module_testimonial_photo_width'), $this->config->get('module_testimonial_photo_height'));
			}

			$data['testimonials'][] = array(
				'testimony'     => utf8_substr(strip_tags(html_entity_decode($result['testimony'], ENT_QUOTES, 'UTF-8')), 0, $this->config->get('module_testimonial_numchars')) . '...',
				'name'          => $result['firstname'] . ' ' . $result['lastname'],
				'website'       => $result['website'],
				'company'       => $result['company'],
				'title'         => $result['title'],
				'photo'         => $photo,
			    'rating'        => (int)$result['rating'],
				'date_added'    => date($this->language->get('date_format_short'), strtotime($result['date_added'])),
				'href'          => $this->url->link('information/testimonial/info', 'testimonial_id=' . $result['testimonial_id'])
			);
		}

		$data['testify'] = $this->url->link('information/testimonial/testify');
		$data['more_testimonials'] = $this->url->link('information/testimonial');

		return $this->load->view('extension/module/testimonial', $data);
	}
}