<?php
/**
 * @package		Testimonial
 * @copyright	Copyright (C) 2015 Fido-X IT (John Simon). All rights reserved. (fido-x.net)
 * @license		GNU General Public License version 3; see http://www.gnu.org/licenses/gpl-3.0.en.html
 */

class ModelFidoTestimonial extends Model {
	public function getTestimonial($testimonial_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "testimonial WHERE testimonial_id = '" . (int)$testimonial_id . "'");

		return $query->row;
	}

	public function getTestimonials($data = array()) {
		$sql = "SELECT * FROM  " . DB_PREFIX . "testimonial t LEFT JOIN  " . DB_PREFIX . "testimonial_to_store t2s ON (t.testimonial_id = t2s.testimonial_id) WHERE t.status = '1'";

		if (!empty($data['language'])) {
			$sql .= " AND t.language_code = '" . $this->db->escape($data['language']) . "'";
		}

		if (!empty($data['featured'])) {
			$sql .= " AND t.featured = '" . (int)$data['featured'] . "'";
		}

		$sql .= " AND t2s.store_id = '" . (int)$this->config->get('config_store_id') . "'";

		$sql .= " ORDER BY t.date_added DESC";

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = $this->db->query($sql);

		return $query->rows;
	}

	public function getTotalTestimonials($data = array()) {
		$sql = "SELECT COUNT(*) AS total FROM  " . DB_PREFIX . "testimonial t LEFT JOIN  " . DB_PREFIX . "testimonial_to_store t2s ON (t.testimonial_id = t2s.testimonial_id) WHERE t.status = '1'";

		if (!empty($data['language'])) {
			$sql .= " AND t.language_code = '" . $this->db->escape($data['language']) . "'";
		}

		$sql .= " AND t2s.store_id = '" . (int)$this->config->get('config_store_id') . "'";

		$query = $this->db->query($sql);

		return $query->row['total'];
	}

	public function addTestimonial($data) {
		$this->db->query("INSERT INTO  " . DB_PREFIX . "testimonial SET firstname = '" . $this->db->escape($data['firstname']) . "', lastname = '" . $this->db->escape($data['lastname']) . "', email = '" . $this->db->escape($data['email']) . "', website = '" . $this->db->escape($data['website']) . "', company = '" . $this->db->escape($data['company']) . "', title = '" . $this->db->escape($data['title']) . "', rating = '" . (int)$data['rating'] . "', language_code = '" . $this->session->data['language'] . "', testimony = '" . $this->db->escape($data['testimony']) . "', status = '" . (int)$this->config->get('testimonial_auto_approve') . "', date_added = NOW(), date_modified = NOW()");

		$testimonial_id = $this->db->getLastId();

		$this->db->query("INSERT INTO  " . DB_PREFIX . "testimonial_to_store SET testimonial_id = '" . (int)$testimonial_id . "', store_id = '" . (int)$this->config->get('config_store_id') . "'");

		$this->cache->delete('testimonial');
	}

	public function emailExists($email) {
		$query = $this->db->query("SELECT COUNT(*) AS total FROM  " . DB_PREFIX . "testimonial WHERE LCASE(email) = LCASE('" . $this->db->escape($email) . "')");

		if ($query->row) {
			return $query->row['total'];
		} else {
			return false;
		}
	}
}
