<?php
class ControllerProductProduct extends Controller {
	private $error = array();

		
		    /* OWC start owc_core_productpageenhanced_hooks.xml */ 
				/* HOOK_PRODUCTPAGEENHANCED_PRODUCT_ADD_FUNCTION */ 
				/* OWC end owc_core_productpageenhanced_hooks.xml */
		
	public function index() {
		$this->load->language('product/product');

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home')
		);

		$this->load->model('catalog/category');

		if (isset($this->request->get['path'])) {
			$path = '';

			$parts = explode('_', (string)$this->request->get['path']);

			$category_id = (int)array_pop($parts);

			foreach ($parts as $path_id) {
				if (!$path) {
					$path = $path_id;
				} else {
					$path .= '_' . $path_id;
				}

				$category_info = $this->model_catalog_category->getCategory($path_id);

				if ($category_info) {
					$data['breadcrumbs'][] = array(
						'text' => $category_info['name'],
						'href' => $this->url->link('product/category', 'path=' . $path)
					);
				}
			}

			// Set the last category breadcrumb

			$category_info = $this->model_catalog_category->getCategory($category_id);

			if ($category_info) {
				$url = '';

				if (isset($this->request->get['sort'])) {
					$url .= '&sort=' . $this->request->get['sort'];
				}

				if (isset($this->request->get['order'])) {
					$url .= '&order=' . $this->request->get['order'];
				}

				if (isset($this->request->get['page'])) {
					$url .= '&page=' . $this->request->get['page'];
				}

				if (isset($this->request->get['limit'])) {
					$url .= '&limit=' . $this->request->get['limit'];
				}

				$data['breadcrumbs'][] = array(
					'text' => $category_info['name'],
					'href' => $this->url->link('product/category', 'path=' . $this->request->get['path'] . $url)
				);
			}
		}

		$this->load->model('catalog/manufacturer');

		if (isset($this->request->get['manufacturer_id'])) {
			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('text_brand'),
				'href' => $this->url->link('product/manufacturer')
			);

			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			if (isset($this->request->get['limit'])) {
				$url .= '&limit=' . $this->request->get['limit'];
			}

			$manufacturer_info = $this->model_catalog_manufacturer->getManufacturer($this->request->get['manufacturer_id']);

			if ($manufacturer_info) {
				$data['breadcrumbs'][] = array(
					'text' => $manufacturer_info['name'],
					'href' => $this->url->link('product/manufacturer/info', 'manufacturer_id=' . $this->request->get['manufacturer_id'] . $url)
				);
			}
		}

		if (isset($this->request->get['search']) || isset($this->request->get['tag'])) {
			$url = '';

			if (isset($this->request->get['search'])) {
				$url .= '&search=' . $this->request->get['search'];
			}

			if (isset($this->request->get['tag'])) {
				$url .= '&tag=' . $this->request->get['tag'];
			}

			if (isset($this->request->get['description'])) {
				$url .= '&description=' . $this->request->get['description'];
			}

			if (isset($this->request->get['category_id'])) {
				$url .= '&category_id=' . $this->request->get['category_id'];
			}

			if (isset($this->request->get['sub_category'])) {
				$url .= '&sub_category=' . $this->request->get['sub_category'];
			}

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			if (isset($this->request->get['limit'])) {
				$url .= '&limit=' . $this->request->get['limit'];
			}

			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('text_search'),
				'href' => $this->url->link('product/search', $url)
			);
		}

		if (isset($this->request->get['product_id'])) {
			$product_id = (int)$this->request->get['product_id'];
		} else {
			$product_id = 0;
		}

		$this->load->model('catalog/product');

		$product_info = $this->model_catalog_product->getProduct($product_id);

		if ($product_info) {
			$url = '';

			if (isset($this->request->get['path'])) {
				$url .= '&path=' . $this->request->get['path'];
			}

			if (isset($this->request->get['filter'])) {
				$url .= '&filter=' . $this->request->get['filter'];
			}

			if (isset($this->request->get['manufacturer_id'])) {
				$url .= '&manufacturer_id=' . $this->request->get['manufacturer_id'];
			}

			if (isset($this->request->get['search'])) {
				$url .= '&search=' . $this->request->get['search'];
			}

			if (isset($this->request->get['tag'])) {
				$url .= '&tag=' . $this->request->get['tag'];
			}

			if (isset($this->request->get['description'])) {
				$url .= '&description=' . $this->request->get['description'];
			}

			if (isset($this->request->get['category_id'])) {
				$url .= '&category_id=' . $this->request->get['category_id'];
			}

			if (isset($this->request->get['sub_category'])) {
				$url .= '&sub_category=' . $this->request->get['sub_category'];
			}

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			if (isset($this->request->get['limit'])) {
				$url .= '&limit=' . $this->request->get['limit'];
			}

			$data['breadcrumbs'][] = array(
				'text' => $product_info['name'],
				'href' => $this->url->link('product/product', $url . '&product_id=' . $this->request->get['product_id'])
			);

			$this->document->setTitle($product_info['meta_title']);
			$this->document->setDescription($product_info['meta_description']);
			$this->document->setKeywords($product_info['meta_keyword']);
			$this->document->addLink($this->url->link('product/product', 'product_id=' . $this->request->get['product_id']), 'canonical');
			//$this->document->addScript('catalog/view/javascript/jquery/magnific/jquery.magnific-popup.min.js');
			
			$this->document->addScript('catalog/view/javascript/jquery/datetimepicker/moment/moment.min.js');
			$this->document->addScript('catalog/view/javascript/jquery/datetimepicker/moment/moment-with-locales.min.js');
			$this->document->addScript('catalog/view/javascript/jquery/datetimepicker/bootstrap-datetimepicker.min.js');
			$this->document->addStyle('catalog/view/javascript/jquery/datetimepicker/bootstrap-datetimepicker.min.css');
			$this->document->addStyle('catalog/view/theme/esh001/stylesheet/glyphicon.css');

			$data['heading_title'] = $product_info['name'];

			$data['text_minimum'] = sprintf($this->language->get('text_minimum'), $product_info['minimum']);
			$data['text_login'] = sprintf($this->language->get('text_login'), $this->url->link('account/login', '', true), $this->url->link('account/register', '', true));

			$this->load->model('catalog/review');

			$data['tab_review'] = sprintf($this->language->get('tab_review'), $product_info['reviews']);

			$data['product_id']    = (int)$this->request->get['product_id'];
			$data['manufacturer']  = $product_info['manufacturer'];

			$this->load->model('tool/image');

			$manufacturer_info = $this->model_catalog_manufacturer->getManufacturer($product_info['manufacturer_id']);

			$data['manufacturer_logo']  = $this->model_tool_image->resize($manufacturer_info['image'], 120, 120);

			$data['manufacturers'] = $this->url->link('product/manufacturer/info', 'manufacturer_id=' . $product_info['manufacturer_id']);
			$data['model']  = $product_info['model'];
			$data['reward'] = $product_info['reward'];
			
			$data['text_points'] = $this->language->get('text_points');
			$data['points']      = $product_info['points'];

			$product_description = html_entity_decode($product_info['description'], ENT_QUOTES, 'UTF-8');
			$data['description'] = $product_description;

			$string_cut = 250;
			$strip_tag_desc = strip_tags($product_description);
			if(strlen($strip_tag_desc) > $string_cut){
				$readmore_link = "<a href='javascript:void(0)' onclick='scrolltodiv(\"product-detail-tab\");return false;'>Read More</a>";
				$data['short_description'] = substr($strip_tag_desc, 0,$string_cut).'.. '.$readmore_link;
			}else{
				$data['short_description'] = $strip_tag_desc;
			}


		    /* OWC start owc_core_productpageenhanced_hooks.xml */ 
				/* HOOK_PRODUCTPAGEENHANCED_PRODUCT_BEFORE_QUANTITY_CHECK */ 
				/* OWC end owc_core_productpageenhanced_hooks.xml */
		
			if ($product_info['quantity'] <= 0) {
				$data['stock'] = $product_info['stock_status'];
			} elseif ($this->config->get('config_stock_display')) {
				$data['stock'] = $product_info['quantity'];
			} else {
				$data['stock'] = $this->language->get('text_instock');
			}


			if ($product_info['image']) {
				$data['popup'] = $this->model_tool_image->resize($product_info['image'], $this->config->get('theme_' . $this->config->get('config_theme') . '_image_popup_width'), $this->config->get('theme_' . $this->config->get('config_theme') . '_image_popup_height'));
			} else {
				$data['popup'] = '';
			}

			if ($product_info['image']) {
				$data['thumb'] = $this->model_tool_image->resize($product_info['image'], $this->config->get('theme_' . $this->config->get('config_theme') . '_image_thumb_width'), $this->config->get('theme_' . $this->config->get('config_theme') . '_image_thumb_height'));
			} else {
				$data['thumb'] = '';
			}

			$data['images'] = array();

			$results = $this->model_catalog_product->getProductImages($this->request->get['product_id']);

			foreach ($results as $result) {
				$data['images'][] = array(
					'popup' => $this->model_tool_image->resize($result['image'], $this->config->get('theme_' . $this->config->get('config_theme') . '_image_popup_width'), $this->config->get('theme_' . $this->config->get('config_theme') . '_image_popup_height')),
					'thumb' => $this->model_tool_image->resize($result['image'], $this->config->get('theme_' . $this->config->get('config_theme') . '_image_additional_width'), $this->config->get('theme_' . $this->config->get('config_theme') . '_image_additional_height'))
				);
			}

			if ($this->customer->isLogged() || !$this->config->get('config_customer_price')) {
				$data['price'] = $this->currency->format($this->tax->calculate($product_info['price'], $product_info['tax_class_id'], $this->config->get('config_tax')), $this->session->data['currency']);
			} else {
				$data['price'] = false;
			}

			if ((float)$product_info['special']) {
				$data['special'] = $this->currency->format($this->tax->calculate($product_info['special'], $product_info['tax_class_id'], $this->config->get('config_tax')), $this->session->data['currency']);
			} else {
				$data['special'] = false;
			}

			if ($this->config->get('config_tax')) {
				$data['tax'] = $this->currency->format((float)$product_info['special'] ? $product_info['special'] : $product_info['price'], $this->session->data['currency']);
			} else {
				$data['tax'] = false;
			}

			$discounts = $this->model_catalog_product->getProductDiscounts($this->request->get['product_id']);

			$data['discounts'] = array();

			foreach ($discounts as $discount) {
				$data['discounts'][] = array(
					'quantity' => $discount['quantity'],
					'price'    => $this->currency->format($this->tax->calculate($discount['price'], $product_info['tax_class_id'], $this->config->get('config_tax')), $this->session->data['currency'])
				);
			}

			$data['options'] = array();

			foreach ($this->model_catalog_product->getProductOptions($this->request->get['product_id']) as $option) {
				$product_option_value_data = array();

				foreach ($option['product_option_value'] as $option_value) {
							
		    /* OWC start owc_core_productpageenhanced_hooks.xml */ 
				if (!$option_value['subtract'] || ($option_value['quantity'] > 0 /* HOOK_PRODUCTPAGEENHANCED_PRODUCT_DISPLAY_OUT_OF_STOCK_OPTIONS */)) { 
				/* OWC end owc_core_productpageenhanced_hooks.xml */
		
						if ((($this->config->get('config_customer_price') && $this->customer->isLogged()) || !$this->config->get('config_customer_price')) && (float)$option_value['price']) {
							$price = $this->currency->format($this->tax->calculate($option_value['price'], $product_info['tax_class_id'], $this->config->get('config_tax') ? 'P' : false), $this->session->data['currency']);
						} else {
							$price = false;
						}

		
		    /* OWC start owc_core_productpageenhanced_hooks.xml */ 
				/* HOOK_PRODUCTPAGEENHANCED_PRODUCT_BEFORE_ADD_OPTION_TO_ARRAY */ 
				/* OWC end owc_core_productpageenhanced_hooks.xml */
		
						$product_option_value_data[] = array(
							'product_option_value_id' => $option_value['product_option_value_id'],
							'option_value_id'         => $option_value['option_value_id'],
							'name'                    => $option_value['name'],
		
		    /* OWC start owc_core_productpageenhanced_hooks.xml */ 
				/* HOOK_PRODUCTPAGEENHANCED_PRODUCT_ADD_OPTION_TO_ARRAY */ 
				/* OWC end owc_core_productpageenhanced_hooks.xml */
		
							'image'                   => $this->model_tool_image->resize($option_value['image'], 50, 50),
							'price'                   => $price,
							'price_prefix'            => $option_value['price_prefix']
						);
					}
				}

				$data['options'][] = array(
					'product_option_id'    => $option['product_option_id'],
					'product_option_value' => $product_option_value_data,
					'option_id'            => $option['option_id'],
					'name'                 => $option['name'],
					'type'                 => $option['type'],
					'value'                => $option['value'],
					'required'             => $option['required']
				);
			}

			if ($product_info['minimum']) {
				$data['minimum'] = $product_info['minimum'];
			} else {
				$data['minimum'] = 1;
			}

			$data['review_status'] = $this->config->get('config_review_status');

			if ($this->config->get('config_review_guest') || $this->customer->isLogged()) {
				$data['review_guest'] = true;
			} else {
				$data['review_guest'] = false;
			}

			if ($this->customer->isLogged()) {
				$data['customer_name'] = $this->customer->getFirstName() . '&nbsp;' . $this->customer->getLastName();
			} else {
				$data['customer_name'] = '';
			}

			$data['reviews'] = sprintf($this->language->get('text_reviews'), (int)$product_info['reviews']);
			$data['rating'] = (int)$product_info['rating'];

			// Captcha
			if ($this->config->get('captcha_' . $this->config->get('config_captcha') . '_status') && in_array('review', (array)$this->config->get('config_captcha_page'))) {
				$data['captcha'] = $this->load->controller('extension/captcha/' . $this->config->get('config_captcha'));
			} else {
				$data['captcha'] = '';
			}

			$data['share'] = $this->url->link('product/product', 'product_id=' . (int)$this->request->get['product_id']);

			$data['attribute_groups'] = $this->model_catalog_product->getProductAttributes($this->request->get['product_id']);

			$data['products'] = array();
		
		    /* OWC start owc_core_productpageenhanced_hooks.xml */ 
				/* HOOK_PRODUCTPAGEENHANCED_BEFORE_PRODUCT_LOOP */ 
		
		/* OWC start owc_productpageenhanced_short_description.xml */		
		/* Single product settings */	
    $data['sd_html_product_position1']                = "";
    $data['sd_html_product_position2']                = "";
  	$data['sd_html_product_position3']                = "";		  	
				
		if ($this->OwcLoader->OwcProductPageEnhancedShortDescription->checkStatus()) {		  
  		
		  if (isset($product_info)) {
		    $owc_short_description = $this->OwcLoader->OwcProductPageEnhancedShortDescription->formatShortDescription($product_info);	
		    
		    $data['sd_html_product_position1'] = $this->OwcLoader->OwcProductPageEnhancedShortDescription->renderProductPageData($owc_short_description, 1);
  		  $data['sd_html_product_position2'] = $this->OwcLoader->OwcProductPageEnhancedShortDescription->renderProductPageData($owc_short_description, 2);
  		  $data['sd_html_product_position3'] = $this->OwcLoader->OwcProductPageEnhancedShortDescription->renderProductPageData($owc_short_description, 3);					
  		  $data['sd_html_product_position4'] = $this->OwcLoader->OwcProductPageEnhancedShortDescription->renderProductPageData($owc_short_description, 4);					
		  }			
		}		
		/* OWC end owc_productpageenhanced_short_description.xml */ 
		
		
		/* OWC start owc_productpageenhanced_short_description.xml */			 
		/* Product list settings */
		$owc_productpageenhanced_show_short_description   = 0; 		
    $owc_productpageenhanced_is_module                = 0; 	  
    $owc_short_description                            = "";
    $owc_description                                  = "";
  	$filetype                                         = "";    
				
		if ($this->OwcLoader->OwcProductPageEnhancedShortDescription->checkStatus()) {
		  
		  $filetype = explode('_', basename(__FILE__));
  		$filetype = str_replace(".php", "", $filetype[sizeof($filetype)-1]);	  	
  		
			$owc_productpageenhanced_show_short_description     = $this->OwcLoader->OwcProductPageEnhanced->getShowHideOnPageAndModules('owc_productpageenhanced_sd_show_', $filetype, isset($owc_productpageenhanced_sd_show_override) ? $owc_productpageenhanced_sd_show_override : 0); 		
      $owc_productpageenhanced_is_module                  = in_array($filetype, array('featured', 'special', 'bestseller', 'latest', 'product'));
			if (strpos(basename(__FILE__), 'owc_listallproducts_catalog_module') !== false) {
				$owc_productpageenhanced_is_module = true;
			}  	  		 
		}		
		/* OWC end owc_productpageenhanced_short_description.xml */ 
		
		
		/* OWC start owc_productpageenhanced.xml */		
		if($this->config->get('owc_productpageenhanced_module_status')){
		  if ($this->config->get('owc_productpageenhanced_include_css')) {
		    if ($this->OwcLoader->OwcBase->isJournal3()) {
		      $this->document->addStyle('catalog/view/theme/default/stylesheet/owc/owc_productpageenhanced.css');
		    } else {
		      $this->document->addStyle('catalog/view/theme/default/stylesheet/owc/owc_productpageenhanced.css?v=' . OwcProductPageEnhanced::VERSION);
		    }  
		  }
		  if ($this->config->get('owc_productpageenhanced_include_js_equal_heights')) {
		    if ($this->OwcLoader->OwcBase->isJournal3()) {
		      $this->document->addScript('catalog/view/javascript/owc/owc_productpageenhanced-eh.js');
		    } else {
		      $this->document->addScript('catalog/view/javascript/owc/owc_productpageenhanced-eh.js?v=' . OwcProductPageEnhanced::VERSION);
		    }
		  }  
		}
		/* OWC end owc_productpageenhanced.xml */ 
		
				/* OWC end owc_core_productpageenhanced_hooks.xml */
		

			$results = $this->model_catalog_product->getProductRelated($this->request->get['product_id']);

			foreach ($results as $result) {
				if ($result['image']) {
					$image = $this->model_tool_image->resize($result['image'], $this->config->get('theme_' . $this->config->get('config_theme') . '_image_related_width'), $this->config->get('theme_' . $this->config->get('config_theme') . '_image_related_height'));
				} else {
					$image = $this->model_tool_image->resize('placeholder.png', $this->config->get('theme_' . $this->config->get('config_theme') . '_image_related_width'), $this->config->get('theme_' . $this->config->get('config_theme') . '_image_related_height'));
				}

				if ($this->customer->isLogged() || !$this->config->get('config_customer_price')) {
					$price = $this->currency->format($this->tax->calculate($result['price'], $result['tax_class_id'], $this->config->get('config_tax')), $this->session->data['currency']);
				} else {
					$price = false;
				}

				if ((float)$result['special']) {
					$special = $this->currency->format($this->tax->calculate($result['special'], $result['tax_class_id'], $this->config->get('config_tax')), $this->session->data['currency']);
				} else {
					$special = false;
				}

				if ($this->config->get('config_tax')) {
					$tax = $this->currency->format((float)$result['special'] ? $result['special'] : $result['price'], $this->session->data['currency']);
				} else {
					$tax = false;
				}

				if ($this->config->get('config_review_status')) {
					$rating = (int)$result['rating'];
				} else {
					$rating = false;
				}

				$related_product = array(
					'product_id'  => $result['product_id'],
					'thumb'       => $image,
					'name'        => $result['name'],
					'description' => utf8_substr(trim(strip_tags(html_entity_decode($result['description'], ENT_QUOTES, 'UTF-8'))), 0, $this->config->get('theme_' . $this->config->get('config_theme') . '_product_description_length')) . '..',
					'price'       => $price,
					'special'     => $special,

		    /* OWC start owc_core_productpageenhanced_hooks.xml */
				/* HOOK_PRODUCTPAGEENHANCED_PRODUCT_ADD_TO_ARRAY */

		  /* OWC start owc_productpageenhanced_short_description.xml */
			'short_description'      => $this->OwcLoader->OwcHelper->getProductArrayField(get_defined_vars(), $filetype,  'owc_short_description'),
			/* OWC end owc_productpageenhanced_short_description.xml */
			
				/* OWC end owc_core_productpageenhanced_hooks.xml */
		
					'tax'         => $tax,
					'stock_status'=> $result['quantity'] <= 0 ? strtolower($result['stock_status']) : '',
					'minimum'     => $result['minimum'] > 0 ? $result['minimum'] : 1,
					'rating'      => $rating,
					'href'        => $this->url->link('product/product', 'product_id=' . $result['product_id']),
					'quick'   	  => $this->url->link('product/quick_view', 'path=' . $this->request->get['path'] . '&product_id=' . $result['product_id']),
				);

				$data['product_box'] = $this->load->controller('extension/module/product_box',$related_product);

				$data['products'][]  = $data['product_box'];

			}
			//echo "<pre>";print_r($data); exit();

			$data['tags'] = array();

			if ($product_info['tag']) {
				$tags = explode(',', $product_info['tag']);

				foreach ($tags as $tag) {
					$data['tags'][] = array(
						'tag'  => trim($tag),
						'href' => $this->url->link('product/search', 'tag=' . trim($tag))
					);
				}
			}

			$data['recurrings'] = $this->model_catalog_product->getProfiles($this->request->get['product_id']);

			$this->model_catalog_product->updateViewed($this->request->get['product_id']);

			$data['breadcrumb'] = $this->load->controller('common/breadcrumb',$data);
			
			$data['column_left'] = $this->load->controller('common/column_left');
			$data['column_right'] = $this->load->controller('common/column_right');
			$data['content_top'] = $this->load->controller('common/content_top');
			$data['content_bottom'] = $this->load->controller('common/content_bottom');
			$data['footer'] = $this->load->controller('common/footer');
			$data['header'] = $this->load->controller('common/header');


		    /* OWC start owc_core_productpageenhanced_hooks.xml */
				/* HOOK_PRODUCTPAGEENHANCED_PRODUCT_BEFORE_VIEW */
		
		/* OWC start owc_productpageenhanced.xml */				
		if (isset($this->data) && is_array($this->data)) {
		  $this->data['html_list_label'] = "";
  		if($this->config->get('owc_productpageenhanced_module_status')){
  		  if (isset($this->session->data['owc_list_before_price_label'])) {
  		    $this->data['html_list_label']  = $this->session->data['owc_list_before_price_label'];
  		  }
  		}
		} else {
		  $data['html_list_label'] = "";
  		if($this->config->get('owc_productpageenhanced_module_status')){
  		  if (isset($this->session->data['owc_list_before_price_label'])) {
  		    $data['html_list_label']  = $this->session->data['owc_list_before_price_label'];
  		  }
  		}
		}		
		/* OWC end owc_productpageenhanced.xml */ 
		
				/* OWC end owc_core_productpageenhanced_hooks.xml */
		
			$this->response->setOutput($this->load->view('product/product', $data));
		} else {
			$url = '';

			if (isset($this->request->get['path'])) {
				$url .= '&path=' . $this->request->get['path'];
			}

			if (isset($this->request->get['filter'])) {
				$url .= '&filter=' . $this->request->get['filter'];
			}

			if (isset($this->request->get['manufacturer_id'])) {
				$url .= '&manufacturer_id=' . $this->request->get['manufacturer_id'];
			}

			if (isset($this->request->get['search'])) {
				$url .= '&search=' . $this->request->get['search'];
			}

			if (isset($this->request->get['tag'])) {
				$url .= '&tag=' . $this->request->get['tag'];
			}

			if (isset($this->request->get['description'])) {
				$url .= '&description=' . $this->request->get['description'];
			}

			if (isset($this->request->get['category_id'])) {
				$url .= '&category_id=' . $this->request->get['category_id'];
			}

			if (isset($this->request->get['sub_category'])) {
				$url .= '&sub_category=' . $this->request->get['sub_category'];
			}

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			if (isset($this->request->get['limit'])) {
				$url .= '&limit=' . $this->request->get['limit'];
			}

			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('text_error'),
				'href' => $this->url->link('product/product', $url . '&product_id=' . $product_id)
			);


			$this->document->setTitle($this->language->get('text_error'));

			$data['heading_title'] = $this->language->get('text_error');

			$data['continue'] = $this->url->link('common/home');

			$this->response->addHeader($this->request->server['SERVER_PROTOCOL'] . ' 404 Not Found');

			$data['breadcrumb'] = $this->load->controller('common/breadcrumb',$data);

			$data['column_left'] = $this->load->controller('common/column_left');
			$data['column_right'] = $this->load->controller('common/column_right');
			$data['content_top'] = $this->load->controller('common/content_top');
			$data['content_bottom'] = $this->load->controller('common/content_bottom');
			$data['footer'] = $this->load->controller('common/footer');
			$data['header'] = $this->load->controller('common/header');


		    /* OWC start owc_core_productpageenhanced_hooks.xml */
				/* HOOK_PRODUCTPAGEENHANCED_PRODUCT_BEFORE_VIEW */
		
		/* OWC start owc_productpageenhanced.xml */				
		if (isset($this->data) && is_array($this->data)) {
		  $this->data['html_list_label'] = "";
  		if($this->config->get('owc_productpageenhanced_module_status')){
  		  if (isset($this->session->data['owc_list_before_price_label'])) {
  		    $this->data['html_list_label']  = $this->session->data['owc_list_before_price_label'];
  		  }
  		}
		} else {
		  $data['html_list_label'] = "";
  		if($this->config->get('owc_productpageenhanced_module_status')){
  		  if (isset($this->session->data['owc_list_before_price_label'])) {
  		    $data['html_list_label']  = $this->session->data['owc_list_before_price_label'];
  		  }
  		}
		}		
		/* OWC end owc_productpageenhanced.xml */ 
		
				/* OWC end owc_core_productpageenhanced_hooks.xml */
		
			$this->response->setOutput($this->load->view('error/not_found', $data));
		}
	}

	public function review() {
		$this->load->language('product/product');

		$this->load->model('catalog/review');

		if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}

		$data['reviews'] = array();

		$review_total = $this->model_catalog_review->getTotalReviewsByProductId($this->request->get['product_id']);

		$results = $this->model_catalog_review->getReviewsByProductId($this->request->get['product_id'], ($page - 1) * 5, 5);

		foreach ($results as $result) {
			$data['reviews'][] = array(
				'author'     => $result['author'],
				'text'       => nl2br($result['text']),
				'rating'     => (int)$result['rating'],
				'date_added' => date($this->language->get('date_format_short'), strtotime($result['date_added']))
			);
		}

		$pagination = new Pagination();
		$pagination->total = $review_total;
		$pagination->page = $page;
		$pagination->limit = 5;
		$pagination->url = $this->url->link('product/product/review', 'product_id=' . $this->request->get['product_id'] . '&page={page}');

		$data['pagination'] = $pagination->render();

		$data['results'] = sprintf($this->language->get('text_pagination'), ($review_total) ? (($page - 1) * 5) + 1 : 0, ((($page - 1) * 5) > ($review_total - 5)) ? $review_total : ((($page - 1) * 5) + 5), $review_total, ceil($review_total / 5));


		    /* OWC start owc_core_productpageenhanced_hooks.xml */
				/* HOOK_PRODUCTPAGEENHANCED_PRODUCT_BEFORE_VIEW */
		
		/* OWC start owc_productpageenhanced.xml */				
		if (isset($this->data) && is_array($this->data)) {
		  $this->data['html_list_label'] = "";
  		if($this->config->get('owc_productpageenhanced_module_status')){
  		  if (isset($this->session->data['owc_list_before_price_label'])) {
  		    $this->data['html_list_label']  = $this->session->data['owc_list_before_price_label'];
  		  }
  		}
		} else {
		  $data['html_list_label'] = "";
  		if($this->config->get('owc_productpageenhanced_module_status')){
  		  if (isset($this->session->data['owc_list_before_price_label'])) {
  		    $data['html_list_label']  = $this->session->data['owc_list_before_price_label'];
  		  }
  		}
		}		
		/* OWC end owc_productpageenhanced.xml */ 
		
				/* OWC end owc_core_productpageenhanced_hooks.xml */
		
		$this->response->setOutput($this->load->view('product/review', $data));
	}

	public function write() {
		$this->load->language('product/product');

		$json = array();

		if ($this->request->server['REQUEST_METHOD'] == 'POST') {
			if ((utf8_strlen($this->request->post['name']) < 3) || (utf8_strlen($this->request->post['name']) > 25)) {
				$json['error'] = $this->language->get('error_name');
			}

			if ((utf8_strlen($this->request->post['text']) < 25) || (utf8_strlen($this->request->post['text']) > 1000)) {
				$json['error'] = $this->language->get('error_text');
			}

			if (empty($this->request->post['rating']) || $this->request->post['rating'] < 0 || $this->request->post['rating'] > 5) {
				$json['error'] = $this->language->get('error_rating');
			}

			// Captcha
			if ($this->config->get('captcha_' . $this->config->get('config_captcha') . '_status') && in_array('review', (array)$this->config->get('config_captcha_page'))) {
				$captcha = $this->load->controller('extension/captcha/' . $this->config->get('config_captcha') . '/validate');

				if ($captcha) {
					$json['error'] = $captcha;
				}
			}

			if (!isset($json['error'])) {
				$this->load->model('catalog/review');

				$this->model_catalog_review->addReview($this->request->get['product_id'], $this->request->post);

				$json['success'] = $this->language->get('text_success');
			}
		}

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}

	public function getRecurringDescription() {
		$this->load->language('product/product');
		$this->load->model('catalog/product');

		if (isset($this->request->post['product_id'])) {
			$product_id = $this->request->post['product_id'];
		} else {
			$product_id = 0;
		}

		if (isset($this->request->post['recurring_id'])) {
			$recurring_id = $this->request->post['recurring_id'];
		} else {
			$recurring_id = 0;
		}

		if (isset($this->request->post['quantity'])) {
			$quantity = $this->request->post['quantity'];
		} else {
			$quantity = 1;
		}

		$product_info = $this->model_catalog_product->getProduct($product_id);
		
		$recurring_info = $this->model_catalog_product->getProfile($product_id, $recurring_id);

		$json = array();

		if ($product_info && $recurring_info) {
			if (!$json) {
				$frequencies = array(
					'day'        => $this->language->get('text_day'),
					'week'       => $this->language->get('text_week'),
					'semi_month' => $this->language->get('text_semi_month'),
					'month'      => $this->language->get('text_month'),
					'year'       => $this->language->get('text_year'),
				);

				if ($recurring_info['trial_status'] == 1) {
					$price = $this->currency->format($this->tax->calculate($recurring_info['trial_price'] * $quantity, $product_info['tax_class_id'], $this->config->get('config_tax')), $this->session->data['currency']);
					$trial_text = sprintf($this->language->get('text_trial_description'), $price, $recurring_info['trial_cycle'], $frequencies[$recurring_info['trial_frequency']], $recurring_info['trial_duration']) . ' ';
				} else {
					$trial_text = '';
				}

				$price = $this->currency->format($this->tax->calculate($recurring_info['price'] * $quantity, $product_info['tax_class_id'], $this->config->get('config_tax')), $this->session->data['currency']);

				if ($recurring_info['duration']) {
					$text = $trial_text . sprintf($this->language->get('text_payment_description'), $price, $recurring_info['cycle'], $frequencies[$recurring_info['frequency']], $recurring_info['duration']);
				} else {
					$text = $trial_text . sprintf($this->language->get('text_payment_cancel'), $price, $recurring_info['cycle'], $frequencies[$recurring_info['frequency']], $recurring_info['duration']);
				}

				$json['success'] = $text;
			}
		}

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}
}
